                        // frac.cc
#include "frac.h"

// this algorithm doesn't alter _num and _denom signs
// precondition: _denom != 0
void fraction::reduce()
{
   long  N=_num, D=_denom, R;

   while ((R = N % D)) // != 0
   {
      N=D;
      D=R;
   }
   // MCD is D

   if (D!=1 && D!=-1)   // optional test
   {
      _num /= D;
      _denom /= D;
   }
}

ostream& operator<<(ostream& os, const fraction& f)
{
   return os << f._num << '/' << f._denom;   
}

istream& operator>>(istream& is, fraction& f)
{
   is >> f._num >> f._denom;
   f.reduce();
   return is;
}
